// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUIToolBar;
import org.apache.myfaces.tobago.renderkit.css.CustomClass;
import org.apache.myfaces.tobago.renderkit.css.Style;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 <p/>
  Renders a toolbar.<p />
  Allowed subcomponents are subtypes of UICommand i.e.
  <code>'button'</code> and <code>'link'</code> tags.
  These are rendered by ToolbarRenderer, so the result has
  no difference.<p />
  To add an drop down menu to a button add a facet <code>'dropDownMenu'</code>
  containing a
  <a href="menu.html"><code>&lt;tc:menu></code></a>
  tag to the button. Label's and Image's on those menu tag's are ignored
  and replaced by the renderer.
  <pre>
       &lt;tc:button onclick="alert('test 0')"
           label="Alert 0" &gt;
         &lt;f:facet name="dropDownMenu"&gt;
           &lt;tc:menu&gt;
             &lt;tc:menuCommand onclick="alert('test 1')" label="Alert 1"/&gt;
             &lt;tc:menuCommand onclick="alert('test 2')" label="Alert 2"/&gt;
             &lt;tc:menuCommand onclick="alert('test 3')" label="Alert 3"/&gt;
           &lt;/tc:menu&gt;
         &lt;/f:facet&gt;
       &lt;/tc:button&gt;
       </pre>
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.ToolBarTagDeclaration}.
 */
public class UIToolBar
    extends AbstractUIToolBar implements Visual {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.ToolBar";

  public static final String COMPONENT_FAMILY = "javax.faces.Panel";


  enum PropertyKeys {
    orientation,
    markup,
    labelPosition,
    customClass,
    iconSize,
    style,
    tip,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  /**
  Orientation of toolbar
  <br />Default: <code>left</code><br />Allowed Values: <code>left,right</code>
  */
  public java.lang.String getOrientation() {
    java.lang.String orientation = (java.lang.String) getStateHelper().eval(PropertyKeys.orientation);
    if (orientation != null) {
      return orientation;
    }
    return "left";
  }

  public void setOrientation(java.lang.String orientation) {
    getStateHelper().put(PropertyKeys.orientation, orientation);
  }

  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  Position of the button label, possible values are: right, bottom, off.
   If toolbar is facet of box: bottom is changed to right!
  <br />Default: <code>bottom</code><br />Allowed Values: <code>bottom,right,off</code>
  */
  public java.lang.String getLabelPosition() {
    java.lang.String labelPosition = (java.lang.String) getStateHelper().eval(PropertyKeys.labelPosition);
    if (labelPosition != null) {
      return labelPosition;
    }
    return "bottom";
  }

  public void setLabelPosition(java.lang.String labelPosition) {
    getStateHelper().put(PropertyKeys.labelPosition, labelPosition);
  }

  /**
  Sets a CSS class in its parent, if the parent supports it.

   Which this feature it is possible to put a CSS class name into a component with the <tc:style> tag. Example:

   <pre>
   &lt;tc:in>
     &lt;tc:style customClass="my-emphasized"/>
   &lt;/tc:in>
   </pre>

   One capability is, to used external CSS libs.
   <br/>
   This feature should not be used imprudent.
   Because it might be unstable against changes in the renderered HTML code.

  */
  public org.apache.myfaces.tobago.renderkit.css.CustomClass getCustomClass() {
    return (org.apache.myfaces.tobago.renderkit.css.CustomClass) getStateHelper().eval(PropertyKeys.customClass);
  }

  public void setCustomClass(org.apache.myfaces.tobago.renderkit.css.CustomClass customClass) {
    getStateHelper().put(PropertyKeys.customClass, customClass);
  }

  /**
  Size of button images, possible values are: small, big, off.
  <br />Default: <code>small</code><br />Allowed Values: <code>small,big,off</code>
  */
  public java.lang.String getIconSize() {
    java.lang.String iconSize = (java.lang.String) getStateHelper().eval(PropertyKeys.iconSize);
    if (iconSize != null) {
      return iconSize;
    }
    return "small";
  }

  public void setIconSize(java.lang.String iconSize) {
    getStateHelper().put(PropertyKeys.iconSize, iconSize);
  }

  /**
  For internal use. Used for rendering, if there is a child tag &lt;tc:style>

  */
  public org.apache.myfaces.tobago.renderkit.css.Style getStyle() {
    return (org.apache.myfaces.tobago.renderkit.css.Style) getStateHelper().eval(PropertyKeys.style);
  }

  public void setStyle(org.apache.myfaces.tobago.renderkit.css.Style style) {
    getStateHelper().put(PropertyKeys.style, style);
  }

  /**
  Text value to display as tooltip.

  */
  public java.lang.String getTip() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.tip);
  }

  public void setTip(java.lang.String tip) {
    getStateHelper().put(PropertyKeys.tip, tip);
  }


}